#ifndef __BEAT_DETECTOR_H__
#define __BEAT_DETECTOR_H__

#include "MusicTypes.h"

#include <stdint.h>
#include <deque>

// TODO Callback or return value on beat?
class BeatDetector
{
	public:
		BeatDetector( uint32_t _history_depth );

		virtual ~BeatDetector();

		void tick( RT_SAMPLE _instant_average );
		//void tick( complex _instant_average );

		inline bool is_beat()
		{
			return beat_ && !old_beat_ && analyzed_ > history_depth_;
		}

	private:
		std::deque<RT_SAMPLE> *history_;
		//std::deque<complex> *complex_history_;
		RT_SAMPLE history_sum_;
		//complex complex_history_sum_;
		const uint32_t history_depth_;
		uint32_t analyzed_;
		bool beat_;
		bool old_beat_;
		bool print_;
};

#endif
