#ifndef __PROTO_FAULT_H__
#define __PROTO_FAULT_H__

#include "ProtoEvent.h"

class ProtoFault : public ProtoEvent
{
	public:
		ProtoFault( float _start_pos = 0.0f, float _end_pos = 0.0f,
				float _displacement = 0.0f );
		virtual ~ProtoFault();

		virtual void Freeze( FILE *_to_file );
		virtual void UnFreeze( std::string _from_file );

		inline void startPosIs( float _start_pos ) {
			start_pos_ = _start_pos;
		}

		inline float startPos() { return start_pos_; }

		inline void endPosIs( float _end_pos ) {
			end_pos_ = _end_pos;
		}

		inline float endPos() { return end_pos_; }

		inline void displacementIs( float _displacement ) {
			displacement_ = _displacement;
		}

		inline float displacement() { return displacement_; }

	protected:
		inline virtual std::string name() { return "Fault"; }

	private:
		// TODO This will cause resolution issues because we can't determine
		// if (x0, y0) and (x1, y1) refer to the same point.
		float start_pos_;
		float end_pos_;

		float displacement_;
};

#endif
