#ifndef __PROTO_SCRIPT_H__
#define __PROTO_SCRIPT_H__

#include "BeatDetector.h"
#include "StereoPCM.h"

#include "ProtoEvent.h"

#include <stdint.h>
#include <string>
#include <queue>
#include <vector>

typedef std::priority_queue< ProtoEvent*, \
					std::vector<ProtoEvent*>, \
					OrderTimedEvent > \
					ProtoEventQueue;

#define N_SONGS 4

class ProtoScript
{
	public:
		virtual ~ProtoScript();

		static void Freeze(
				std::string _filename, StereoPCM const playlist[] );
		static ProtoScript *UnFreeze( std::string _filename );

		bool MoreEvents();
		ProtoEvent *NextEvent();

	protected:
		ProtoScript();

	private:
		static const unsigned long window_size_ = 1024;
		RT_SAMPLE window_[window_size_];

		BeatDetector *subband_detector_[NSUBBANDS];

		ProtoEventQueue *events_;

		void HandleInstant(
				StereoPCM const _playlist[], uint64_t _index, uint64_t _bookmark );
};

#endif
