#ifndef __FAULT_H__
#define __FAULT_H__

#include "TerrainEvent.h"

#include <Terrain/OgreTerrain.h>

class Fault : public TerrainEvent
{
	public:
		virtual void Morph();
		virtual void Morph( float *_height_data );
		virtual ~Fault();

		void pointsIs( float _pct_start, float _pct_end );

		inline void displacementIs( float _displacement ) {
			displacement_ = _displacement;
		}

	protected:
		friend class TerrainEvent;
		static Fault *Random( Ogre::Terrain *_terrain );

	private:
		Fault( Ogre::Terrain *_terrain );

		void pointsIs( long _x_start, long _y_start, long _x_end, long _y_end );

		// Define a normal-form line in terrain space
		long a_;
		long b_;
		long c_;

		long points_; // Avoid repeated multiplication

		float displacement_;
};

#endif
