#include "Script.h"

#include "TerrainEvent.h"

using namespace std;

Script::Script( string _filename, Ogre::Terrain *_terrain ) :
	sim_time_( 0 )
{
	pending_events_ = new TerrainEventQueue();
	active_events_ = new TerrainEventSet();

	ProtoScript *proto = ProtoScript::UnFreeze( _filename );

	while( proto->MoreEvents() ) {
		ProtoEvent *event = proto->NextEvent();

		pending_events_->push( TerrainEvent::FromProto( _terrain, event ) );

		delete event;
	}

	delete proto;
}

Script::~Script()
{
	while( !pending_events_->empty() ) {
		TerrainEvent *te = pending_events_->top();
		pending_events_->pop();
		delete te;
	}
	delete pending_events_;

	for( TerrainEventSet::iterator iter = active_events_->begin();
			iter != active_events_->end(); iter++ ) {
		active_events_->erase( iter );
		delete *iter;
	}
	delete active_events_;
}
