#ifndef __SCRIPT_H__
#define __SCRIPT_H__

#include "ProtoScript.h"
#include "TerrainEvent.h"
#include <Terrain/OgreTerrain.h>

#include <string>
#include <queue>
#include <vector>
#include <set>

typedef std::priority_queue< TerrainEvent*, \
					std::vector<TerrainEvent*>, \
					OrderTimedEvent > \
					TerrainEventQueue;

typedef std::set< TerrainEvent* > TerrainEventSet;

class Script
{
	public:
		Script( std::string _filename, Ogre::Terrain *_terrain );

		~Script();
		
		TerrainEventQueue *pending_events_;
		TerrainEventSet *active_events_;

		void tick( unsigned long _ms );
	private:
		unsigned long sim_time_;
};

#endif
