#include "Viewer.h"

#include "ProtoScript.h"
#include "Script.h"

// SERIOUSLY HACKHACK
#include "Song.h"

#include <string.h>

#include <iostream>
#include <stdlib.h>
#include <time.h>

using namespace std;

//------------------------------------------------------------------------------
	Viewer::Viewer(void)
:	mTerrainGlobals(0),
	mTerrainGroup(0),
	mTerrainsImported(false),
	mInfoLabel(0),
	mAudio(0)
{
}
//------------------------------------------------------------------------------
Viewer::~Viewer(void)
{
}
//------------------------------------------------------------------------------
void Viewer::destroyScene(void)
{
	OGRE_DELETE mTerrainGroup;
	OGRE_DELETE mTerrainGlobals;
	OGRE_DELETE mRenderTime;

	/*
		 while( !pending_terrain_events_->empty() ) {
		 TerrainEvent *te = pending_terrain_events_->top();
		 pending_terrain_events_->pop();
		 delete te;
		 }
		 delete pending_terrain_events_;
	 */

	/*
		 for( TerrainEventSet::iterator iter = active_terrain_events_->begin();
		 iter != active_terrain_events_->end(); iter++ ) {
		 active_terrain_events_->erase( iter );
		 delete *iter;
		 }
		 delete active_terrain_events_;
	 */

	delete script_;
}
//------------------------------------------------------------------------------
void getTerrainImage(bool flipX, bool flipY, Ogre::Image& img)
{
	img.load("terrain.png",
			Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
	if (flipX) {
		img.flipAroundY();
	}
	if (flipY) {
		img.flipAroundX();
	}
}
//------------------------------------------------------------------------------
void Viewer::defineTerrain(long x, long y)
{
	Ogre::String filename = mTerrainGroup->generateFilename(x, y);
	if (Ogre::ResourceGroupManager::getSingleton().resourceExists(
				mTerrainGroup->getResourceGroup(), filename)) {
		mTerrainGroup->defineTerrain(x, y);
	} else {
		Ogre::Image img;
		getTerrainImage(x % 2 != 0, y % 2 != 0, img);
		mTerrainGroup->defineTerrain(x, y, &img);
		mTerrainsImported = true;
	}
}
//------------------------------------------------------------------------------
void Viewer::initBlendMaps(Ogre::Terrain* terrain)
{
	Ogre::TerrainLayerBlendMap* blendMap0 = terrain->getLayerBlendMap(1);
	Ogre::TerrainLayerBlendMap* blendMap1 = terrain->getLayerBlendMap(2);
	Ogre::Real minHeight0 = 70;
	Ogre::Real fadeDist0 = 40;
	Ogre::Real minHeight1 = 70;
	Ogre::Real fadeDist1 = 15;
	float* pBlend1 = blendMap1->getBlendPointer();
	for (Ogre::uint16 y = 0; y < terrain->getLayerBlendMapSize(); ++y) {
		for (Ogre::uint16 x = 0; x < terrain->getLayerBlendMapSize(); ++x) {
			Ogre::Real tx, ty;

			blendMap0->convertImageToTerrainSpace(x, y, &tx, &ty);
			Ogre::Real height = terrain->getHeightAtTerrainPosition(tx, ty);
			Ogre::Real val = (height - minHeight0) / fadeDist0;
			val = Ogre::Math::Clamp(val, (Ogre::Real)0, (Ogre::Real)1);

			val = (height - minHeight1) / fadeDist1;
			val = Ogre::Math::Clamp(val, (Ogre::Real)0, (Ogre::Real)1);
			*pBlend1++ = val;
		}
	}
	blendMap0->dirty();
	blendMap1->dirty();
	blendMap0->update();
	blendMap1->update();
}
//------------------------------------------------------------------------------
void Viewer::configureTerrainDefaults(Ogre::Light* light)
{
	mTerrainGlobals->setMaxPixelError(8);
	mTerrainGlobals->setCompositeMapDistance(3000);
	mTerrainGlobals->setLightMapDirection(light->getDerivedDirection());
	mTerrainGlobals->setCompositeMapAmbient(mSceneMgr->getAmbientLight());
	mTerrainGlobals->setCompositeMapDiffuse(light->getDiffuseColour());

	Ogre::Terrain::ImportData &defaultimp =
		mTerrainGroup->getDefaultImportSettings();
	defaultimp.terrainSize = 513;
	defaultimp.worldSize = 12000.0f;
	defaultimp.inputScale = 600;
	defaultimp.minBatchSize = 33;
	defaultimp.maxBatchSize = 65;

	defaultimp.layerList.resize(3);
	defaultimp.layerList[0].worldSize = 100;
	defaultimp.layerList[0].textureNames.push_back(
			"dirt_grayrocky_diffusespecular.dds");
	defaultimp.layerList[0].textureNames.push_back(
			"dirt_grayrocky_normalheight.dds");
	defaultimp.layerList[1].worldSize = 30;
	defaultimp.layerList[1].textureNames.push_back(
			"grass_green-01_diffusespecular.dds");
	defaultimp.layerList[1].textureNames.push_back(
			"grass_green-01_normalheight.dds");
	defaultimp.layerList[2].worldSize = 200;
	defaultimp.layerList[2].textureNames.push_back(
			"growth_weirdfungus-03_diffusespecular.dds");
	defaultimp.layerList[2].textureNames.push_back(
			"growth_weirdfungus-03_normalheight.dds");
}
//------------------------------------------------------------------------------
void Viewer::createFrameListener(void)
{
	BaseApplication::createFrameListener();

	mInfoLabel = mTrayMgr->createLabel(OgreBites::TL_TOP, "TInfo", "", 350);
}
//------------------------------------------------------------------------------
void Viewer::createScene(void)
{
	// mCamera is a member of superclass
	mCamera->setPosition(Ogre::Vector3(1683, 50, 2116));
	mCamera->lookAt(Ogre::Vector3(1963, 50, 1660));
	mCamera->setNearClipDistance(0.1);
	mCamera->setFarClipDistance(50000);

	mRenderTime = OGRE_NEW Ogre::Timer();
	mSimTimeMS = 0;

	if( mRoot->getRenderSystem()->getCapabilities()->hasCapability(
				Ogre::RSC_INFINITE_FAR_PLANE) ) {
		mCamera->setFarClipDistance(0);
	}

	Ogre::MaterialManager::getSingleton().setDefaultTextureFiltering(
			Ogre::TFO_ANISOTROPIC);
	Ogre::MaterialManager::getSingleton().setDefaultAnisotropy(7);

	// light
	Ogre::Vector3 lightdir(0.55, -0.3, 0.75);
	lightdir.normalise();

	Ogre::Light *light = mSceneMgr->createLight("tstLight");
	light->setType(Ogre::Light::LT_DIRECTIONAL);
	light->setDirection(lightdir);
	light->setDiffuseColour(Ogre::ColourValue::White);
	light->setSpecularColour(Ogre::ColourValue(0.4, 0.4, 0.4));

	mSceneMgr->setAmbientLight(Ogre::ColourValue(0.2, 0.2, 0.2));

	mSceneMgr->setSkyDome(true, "Examples/CloudySky", 5, 8);

	mTerrainGlobals = OGRE_NEW Ogre::TerrainGlobalOptions();

	// terrain
	mTerrainGroup =
		OGRE_NEW Ogre::TerrainGroup(
				mSceneMgr, Ogre::Terrain::ALIGN_X_Z, 513, 12000.0f);
	mTerrainGroup->setFilenameConvention(
			Ogre::String("ViewerTerrain"), Ogre::String("dat"));
	mTerrainGroup->setOrigin(Ogre::Vector3::ZERO);

	// configure
	configureTerrainDefaults(light);

	// define and load terrains
	mTerrainGroup->defineTerrain( 0, 0, 0.0f ); // Constant-height terrain
	mTerrainGroup->loadAllTerrains(true);

	// Initialize terrain events test
	/*
		 pending_terrain_events_ = new TerrainEventQueue();
		 active_terrain_events_ = new TerrainEventSet();
	 */

	Ogre::Terrain *terrain = mTerrainGroup->getTerrain( 0, 0 );
	//unsigned long time_start = 0;
	srand( time(NULL) );

	script_ = new Script( "../test_script.ts", terrain );

	mTerrainsImported = true;
	if( mTerrainsImported ) {
		Ogre::TerrainGroup::TerrainIterator ti =
			mTerrainGroup->getTerrainIterator();
		while( ti.hasMoreElements() ) {
			Ogre::Terrain* t = ti.getNext()->instance;
			// TODO figure out if we need to call this multiple times
			initBlendMaps(t);
		}
	}

	// Hack to process time zero terrain events
	while( !script_->pending_events_->empty() ) {
		TerrainEvent *next_te = script_->pending_events_->top();
		if( next_te->startTime() > 0 ) {
			break;
		}
		// MEGA HACKHACK TODO Seriously, this is awful
		Song *song = dynamic_cast<Song *>(next_te);
		if( song ) {
			song->dataPtrIs( &playlist_[song->index()] );
			song->Morph();
		}
		script_->pending_events_->pop();
	}

	mTerrainGroup->freeTemporaryResources();

	if( mAudio ) {
		try {
			mAudio->startStream();
		} catch( RtError &err ) {
			cerr << "RtAudio error in startStream" << endl;
			exit( 1 );
		}
	}
}
//------------------------------------------------------------------------------
Ogre::Vector3 Viewer::getUserTerrainPos()
{
	Ogre::Terrain *terrain = mTerrainGroup->getTerrain( 0, 0 );

	Ogre::Vector3 camAt = mCamera->getPosition();
	Ogre::Vector3 camAtT;

	terrain->convertPosition(
			Ogre::Terrain::WORLD_SPACE, camAt, 
			Ogre::Terrain::POINT_SPACE, camAtT );

	return camAtT;
}
//------------------------------------------------------------------------------
bool Viewer::frameRenderingQueued(const Ogre::FrameEvent& evt)
{
	bool ret = BaseApplication::frameRenderingQueued(evt);

	if (mTerrainGroup->isDerivedDataUpdateInProgress()) {
		mTrayMgr->moveWidgetToTray(mInfoLabel, OgreBites::TL_TOP, 0);
		mInfoLabel->show();
		if (mTerrainsImported) {
			mInfoLabel->setCaption("Building terrain, please wait...");
		} else {
			mInfoLabel->setCaption("Updating textures, patience...");
		}
	} else {
		mTrayMgr->removeWidgetFromTray(mInfoLabel);
		mInfoLabel->hide();
		if (mTerrainsImported) {
			mTerrainGroup->saveAllTerrains(true);
			mTerrainsImported = false;
		}
	}

	/*
	Ogre::Terrain *terrain = mTerrainGroup->getTerrain( 0, 0 );

	Ogre::Vector3 camAtT = getUserTerrainPos();
	Ogre::Vector3 camTo;

	if( camAtT.x < 0 ) {
		camAtT.x = 0;
	}
	if( camAtT.z < 0 ) {
		camAtT.y = 0;
	}
	if( camAtT.x > terrain->getSize() ) {
		camAtT.x = terrain->getSize();
	}
	if( camAtT.z > terrain->getSize() ) {
		camAtT.z = terrain->getSize();
	}
	terrain->convertPosition(
			Ogre::Terrain::POINT_SPACE, camAtT,
			Ogre::Terrain::WORLD_SPACE, camTo );

	camTo.y = terrain->getHeightAtPoint( camAtT.x, camAtT.y ) + 10; 
	mCamera->setPosition( camTo );
	*/

	return ret;
}
//------------------------------------------------------------------------------
bool Viewer::frameStarted( const Ogre::FrameEvent& evt )
{
	if( !BaseApplication::frameStarted( evt ) ) {
		return false;
	}

	Ogre::Terrain *terrain = mTerrainGroup->getTerrain( 0, 0 );

	//mSimTimeMS += mRenderTime->getMilliseconds();
	static unsigned long lastRender = 0;
	mRenderTime->reset();

	int count = 0;

	// TODO Manipulate te params based on position
	Ogre::Vector3 userAt = getUserTerrainPos();
	float gain[N_SONGS];

	for( int song_i = 0; song_i < N_SONGS; song_i++ ) {
		StereoPCM *song = &playlist_[song_i];
		int xdist = userAt.x - song->center_x;
		int ydist = userAt.y - song->center_y;
		float distance = sqrt( xdist * xdist + ydist * ydist );
		if( distance <= song->influence ) {
			gain[song_i] = ( song->influence - distance ) / song->influence;
			//gain[song_i] = gain[song_i] * gain[song_i];
		} else {
			gain[song_i] = 0;
		}
	}

	//while( !pending_terrain_events_->empty() ) {
	// SUPER HACKHACK to get performance
	if( mSimTimeMS - lastRender > 1000 ) {
		//float *height_field = terrain->getHeightData();
		while( !script_->pending_events_->empty() ) {
			if( count++ > 1000 ) {
				exit(1); // Kill it if we get behind
			}
			//TerrainEvent *next_te = pending_terrain_events_->top();
			TerrainEvent *next_te = script_->pending_events_->top();
			if( next_te->startTime() > mSimTimeMS ) {
				break;
			}
			//pending_terrain_events_->pop();
			script_->pending_events_->pop();

			assert( 0 <= next_te->index() && N_SONGS > next_te->index() );
			next_te->gain_ = gain[next_te->index()];

			// TODO Performance - we should grab the heightfield once, operate how
			//      we need on the set of events we have, then set it once.
			//next_te->Morph( height_field );
			next_te->Morph();
			delete next_te;
		}

		// Current implementation does not use in-progress events, they're all
		// instant

		//if( event ) {
		lastRender = mSimTimeMS;
		initBlendMaps( terrain );
		terrain->update();
	}

	return true;
	}
	//------------------------------------------------------------------------------
	bool Viewer::mousePressed(
			const OIS::MouseEvent &arg, OIS::MouseButtonID id )
	{
		Ogre::Vector3 tp;
		const Ogre::Vector3 &cp = mCamera->getPosition();
		Ogre::Terrain *terrain = mTerrainGroup->getTerrain( 0, 0 );
		terrain->convertPosition(
				Ogre::Terrain::WORLD_SPACE, cp, Ogre::Terrain::POINT_SPACE, tp );
		terrain->setHeightAtPoint( tp.x, tp.y, tp.z );
		terrain->update();
		char caption[256];
		sprintf(caption,"(%.2g,%.2g,%.2g)",tp.x, tp.y, tp.z);
		mInfoLabel->setCaption(caption);
		return BaseApplication::mousePressed( arg, id );
	}
