#ifndef __MUTEX_H__
#define __MUTEX_H__

#include <pthread.h>

class Mutex
{
	public:
		Mutex(int _type = PTHREAD_MUTEX_NORMAL)
		{
			pthread_mutexattr_t attr;
		
			pthread_mutexattr_init( &attr );
			pthread_mutexattr_settype( &attr, _type );

			pthread_mutex_init( &mutex_, &attr );
		}

		~Mutex()
		{
			pthread_mutex_destroy( &mutex_ );
		}

		inline void Lock()
		{
			pthread_mutex_lock( &mutex_ );
		}

		inline bool TryLock()
		{
			return pthread_mutex_trylock( &mutex_ );
		}

		inline void Unlock()
		{
			pthread_mutex_unlock( &mutex_ );
		}

	private:
		pthread_mutex_t mutex_;
};

#endif
