#include "StereoPCM.h"
#include "ProtoScript.h"
#include "Mad.h"

#include <fcntl.h>
#include <cassert>
#include <deque>
#include <cstring>
#include <iostream>

using namespace std;

StereoPCM playlist[N_SONGS];

int main( int argc, char *argv[] )
{
	assert( argc == 5 );

	for( int i = 0; i < N_SONGS; i++ ) {
		int fildes = open( argv[i+1], O_RDONLY );

		assert( fildes != -1 &&
				fildes != STDERR_FILENO && fildes != STDOUT_FILENO );
		playlist[i].left = new deque<MAD_SAMPLE>();
		playlist[i].right = new deque<MAD_SAMPLE>();
		playlist[i].filename = argv[i+1];

		int rv = decode( fildes, &playlist[i] );

		assert( rv == 0 && playlist[i].sample_rate == 44100 );

		close( fildes );
	}

	init_global_subband_widths();

	string script_name("../test_script.ts");

	ProtoScript::Freeze( script_name, playlist );
	delete ProtoScript::UnFreeze( script_name );

	for( int i = 0; i < N_SONGS; i++ ) {
		delete playlist[i].left;
		delete playlist[i].right;
	}
}
